/*

ascii2bit

author: reinhard@finalmedia.de
26.02.2014

licence: public domain. no warranty.

reading ascii data from stdin
characters "1" or  "0"

collecting 8 of those chars as representing bits
and writing bytewise to stdout. little endian!

usage params

-n  activates newline check. if \n on stdin this also generates \n on stdout
-l  activates looping. endless. if not active, tools exits if EOF is detected
-f  activates flushing after each char

example usage:

	echo -n "10001010101" | ./ascii2bit -f | hd

*/

#include <stdio.h>

char c,x=0;
int i,loop=0,newline=0,flushing=0;

int main(int argc, char *argv[]) {

for (i = 1; i < argc; i++) {
                switch (argv[i][0] == '-' ? argv[i][1] : '?') {
                case 'l':
                        loop=1;
                        break;
                case 'n':
                        newline=1;
                        break;
                case 'f':
                        flushing=1;
                        break;
                case 'h':
                        write(2,"usage: ascii2bit [-l for loop] [-n for newline] [-f for flush] < stdin > stdout\n",82);
                        return 0;
                default:
                        return 0;
                }
        }



do {

for (i=0; i<8; i++) {
c=getc(stdin);
if (c==EOF && loop==0) { return 0; break; }
if (c=='\n' && newline==1) { x='\n'; break; }
if (c=='1') { x = ((x << 1) | 1); }
if (c=='0') { x = ((x << 1) | 0); }
}

putc(x,stdout);
if (flushing==1) { fflush(stdout); }

} while (c!=EOF || loop==1);


return 0;

}
